/*
    File: HammWM.H
    Component of the Stochastic Discrimination Utilities
    Copyright (C) 2002, David C. Lambert <dcl@panix.com>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#ifndef _HAMMWM_H
#define _HAMMWM_H

#include <stdlib.h>
#include "WMSet.H"

class RectWM;

void		HammWMParamUpdate();
WeakModel	*HammWMLoader(int nDims, FILE *dumpFile);
WeakModel	*HammWMCopier(const WeakModel &rhs);
WeakModel	*HammWMFactory(WMSet &set, int nDims);

class HammWM: public WeakModel {
  public:
	static double		RhoMax;
	static double		RhoMin;
	static double		RhoDecay;

	HammWM(int nDims);
	HammWM(int nDims, FILE *dumpFile);
	HammWM(const HammWM &rhs);

	virtual ~HammWM() { delete [] _prototype; }

	virtual	int		containsPoint(double *p);
	virtual	void	writeToFile(FILE *dumpFile);
	virtual void	print(FILE *printFile);

  protected:
	int		_distance;
	int		*_prototype;
};
#endif
