/*
    File: RectWM.H
    Component of the Stochastic Discrimination Utilities
    Copyright (C) 2002, David C. Lambert <dcl@panix.com>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#ifndef _RECTWM_H
#define _RECTWM_H

#include <stdlib.h>
#include "WMSet.H"

class RectWM;

void		RectWMParamUpdate();
WeakModel	*RectWMLoader(int nDims, FILE *dumpFile);
WeakModel	*RectWMCopier(const WeakModel &rhs);
WeakModel	*RectWMFactory(WMSet &set, int nDims);

class RectWM: public WeakModel {
  public:
	RectWM(int nDims);
	RectWM(const RectWM &rhs);
	RectWM(int nDims, FILE *dumpFile);

	virtual ~RectWM() { delete [] _bounds; }

	virtual	int			containsPoint(double *p);
	virtual	void		writeToFile(FILE *dumpFile);
	void				setBounds(int i, double lower, double upper) { DPair &dp = _bounds[i]; dp.v0 = lower; dp.v1 = upper; }

  protected:
	DPair	*_bounds;

	void	_setBoundsUsing(double spanMultiplier, DPair &rectBounds, DPair &dataBounds, double rmid);
};

#endif
